## siconos 4.3.0+dfsg

=== externals/CMakeLists.txt ===
#================================================================
# cmake utilities to build external component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time


# Component name (i.e. target name)
set(COMPONENT externals)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
set(${COMPONENT}_DIRS
  hairer
  netlib/dftemplates
  netlib/odepack
  optim_misc
  optim_misc/ql0001
  SOL/lumod-c
  sort
  tools
)

# boost extras, when c++ is on only
if(WITH_CXX)
  list(APPEND ${COMPONENT}_DIRS numeric_bindings boost_contribs)
  if(WITH_SERIALIZATION AND NOT WITH_SYSTEM_BOOST_SERIALIZATION)
    # FP : in which case do we need this, since boost serialization is required ??
    list(APPEND ${COMPONENT}_DIRS boost_serialization)
  endif()
endif()

# -- Source files to be excluded from build --
set(${COMPONENT}_EXCLUDE_SRCS "SOL/lumod-c/sparselib.c" "SOL/lumod-c/lumod_sparse.c")

# --- Sort ---
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/sort/sort.h")
  if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/sort/sort_common.h")
    set(HAVE_SORT TRUE CACHE INTERNAL "True if sort is available in externals.")
  endif()
endif()

# --- ql0001 ---
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/optim_misc/ql0001/ql0001.f")
  set(HAVE_QL0001 TRUE CACHE INTERNAL "True if ql0001 is available in externals.")
endif()

# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
# No docs for externals.
set(${COMPONENT}_EXCLUDE_DOXY ${${COMPONENT}_DIRS})


# TEST TEST TEST
# ------ include interface ------
# What is needed at build time
# by other targets (numerics etc) to compile with externals.
# It means that a call to
#  target_link_libraries(truc PRIVATE externals)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES
  netlib
   netlib/odepack  # For odepack.h in tests and kernel
   tools           # For SiconosCompat.h in numerics 
   blas_lapack     # For SiconosLapack.h in numerics
   SOL/lumod-c # For lumod_dense.h in numerics
   hairer # For kernel
   )

if(WITH_CXX)
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES
    numeric_bindings boost_contribs) # SiconosAlgebra needs this
endif()

if(HAVE_SORT)
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES sort) # NumericsSparseMatrix needs this
endif()

if(NOT WITH_SYSTEM_SUITESPARSE)
  # else suite sparse is an external dependency of numerics and handled in numerics
  # CMakeLists.txt.
  list(APPEND ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES SuiteSparse/CXSparse)
endif()
# TEST TEST TEST

# ---- Final setup for the library ----

# Windows stuff --> should probably be reviewed and updated
include(WindowsExternalsSetup)

# -- create/setup component target --
include(ComponentSetup)
create_siconos_component(${COMPONENT})

# --- python bindings ---
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  add_subdirectory(swig)
endif()
  
if(WITH_PYTHON_WRAPPER)
  add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
endif()  

# - Extra setup for the component -
if(GAMSCAPI_FOUND AND CMAKE_DL_LIBS) # needed by GAMS (?). Here or in numerics ?
  target_link_libraries(externals PRIVATE ${CMAKE_DL_LIBS})
endif()

# Force c++ compiler for c files (for Visual Studio I guess?)
if(BUILD_AS_CPP)
  file(GLOB_RECURSE C_FILES ${CMAKE_CURRENT_SOURCE_DIR} *.c)
  set_source_files_properties(${C_FILES} PROPERTIES LANGUAGE CXX
    COMPILE_FLAGS -fpermissive) # to allow some nonconforming code to compile
  # set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE CXX)
  # We require C++ 11. PUBLIC to propagate to numerics.
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.8.0")
    target_compile_features(externals PUBLIC cxx_std_11)
  else()
    set_property(TARGET externals PROPERTY CXX_STANDARD 11)
  endif()
else()
  # set_target_properties(${COMPONENT} PROPERTIES LINKER_LANGUAGE C)
  if(${CMAKE_VERSION} VERSION_GREATER "3.8.0")
    target_compile_features(externals PUBLIC c_std_11)
  else()
    set_property(TARGET externals PROPERTY C_STANDARD 11)
  endif()
endif()

# externals lib needs blas while tests need Blas AND lapack.
# Link only at build time.
target_link_libraries(externals PUBLIC $<BUILD_INTERFACE:BLAS::BLAS>)
target_include_directories(externals PRIVATE blas_lapack)

# We don't want warnings from externals libraries.
get_target_property(externals_COMPILE_FLAGS externals COMPILE_OPTIONS)
list(REMOVE_ITEM externals_COMPILE_FLAGS -Wall)
set_target_properties(externals PROPERTIES COMPILE_OPTIONS "${externals_COMPILE_FLAGS}")
target_compile_options(externals PRIVATE "-w")
target_compile_options(externals PRIVATE "-Wno-unused-variable")
target_compile_options(externals PRIVATE "-Wno-unused-parameter")

# - Extras, optional -
# --- SuiteSparse ---
# It is allowed to switch between system or local suitesparse,
# depending on the chosen user option.
# 'local' : use WITH_SYSTEM_SUITESPARSE=OFF, 'system' WITH_SYSTEM_SUITESPARSE=ON (default).
# For 'local' suite sparse, some extra setup is required in externals,
# while system suitesparse is searched for and configured
# during numerics component setup.
if(NOT WITH_SYSTEM_SUITESPARSE)
  include(suite_sparse_setup)
endif()


# ---- Installation ----
# Call siconos_component_install_setup(<COMPONENT>)
# to prepare installation of the current target.
# Before, it's necessary to set:
# 
# - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
#    that contain headers files that must be installed.
# 
# common install
# No headers installed for externals.
set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES)
# set(${COMPONENT}_HDRS_EXCLUDE tools/SiconosCompat.h)
siconos_component_install_setup(${COMPONENT})

# - Optional OCE Renderer setup (install only) -
if(WITH_OCE)
  include(oce_renderer)
endif()

if(WITH_SERIALIZATION AND INSTALL_EXTERNAL_HEADERS AND NOT WITH_SYSTEM_BOOST_SERIALIZATION)
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_load_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_collections_save_imp.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_map.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/boost_serialization/boost/serialization/unordered_set.hpp
    DESTINATION include/siconos/boost/serialization)
endif()

# --- tests ---
include(${COMPONENT}_tests.cmake)


# # List of directories of headers not to be installed
# set(${COMPONENT}_HDRS_EXCLUDE_DIR PATH_SDK/include SOL/lumod-c)
# if(NOT INSTALL_EXTERNAL_HEADERS)
#   list(APPEND ${COMPONENT}_HDRS_EXCLUDE_DIR
#     blas_lapack
#     hairer
#     netlib/dftemplates
#     netlib/odepack
#     optim_misc
#     optim_misc/ql0001
#     sort
#     boost_contribs
#     tools)
# endif()

# # List of specific headers not to be installed
# set(${COMPONENT}_HDRS_EXCLUDE tools/SiconosCompat.h)

=== kernel/CMakeLists.txt ===
#================================================================
# cmake utilities to build kernel component
#================================================================
#
# The objective is to call component_setup to create the target <COMPONENT>.
# Before, it's necessary to set:
# 
# - COMPONENT component name
# - <COMPONENT>_DIRS: the list of paths (relative to CMAKE_CURRENT_SOURCE_DIR) that
#   contain source files
# - <COMPONENT>_EXCLUDE_SRCS: the list of files, in <COMPONENT>_DIRS, that must be excluded
#   from build.
# - <COMPONENT>_INTERFACE_INCLUDE_DIRECTORIES: a list of directories
#   to populate the interface of the target for include directories at build time

# Component name (i.e. target name)
set(COMPONENT kernel)
message("-- Set up for ${PROJECT_NAME}_${COMPONENT} library ...\n")

# ------ source directories for current component ------
# What is needed by component to compile ?
# List here all directories that contain sources files
# for current component.
# Path must be relative to component path (i.e. to CMAKE_CURRENT_SOURCE_DIR)
set(${COMPONENT}_DIRS
  src/.
  src/utils
  src/utils/SiconosAlgebra
  src/utils/SiconosException
  src/utils/SiconosMemory
  src/utils/SiconosSharedLibrary
  src/utils/SiconosTools
  src/utils/ProgressBar
  src/plugin
  src/modelingTools
  src/simulationTools
)

# -- Documentation --
# List of directories for which no doxygen doc will be generated
# By default all directories matching "test" are excluded.
set(${COMPONENT}_EXCLUDE_DOXY src/utils/SiconosTools
  # if included, it breaks swig process for mechanics
  )

# ------ include interface ------
# What is needed at build time
# by other targets to compile with current component.
# 
# It means that a call to
#  target_link_libraries(truc PRIVATE kernel)
# will imply -I<dirs> with dirs listed in
# ${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES.
#
# If all dirs are required, just set
# set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES ${${COMPONENT}_DIRS})
set(${COMPONENT}_INTERFACE_INCLUDE_DIRECTORIES ${${COMPONENT}_DIRS})

# ---- Final setup for the library ----

# Windows stuff
include(WindowsKernelSetup)

# -- create/setup component target --
include(ComponentSetup)
create_siconos_component(${COMPONENT})

# We require C++ 11. PUBLIC to propagate to other components.
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.8.0")
  target_compile_features(kernel PUBLIC cxx_std_11)
else()
  set_property(TARGET kernel PROPERTY CXX_STANDARD 11)
endif()

# --- Extra setup for the component ---

# Links with other Siconos components
target_link_libraries(kernel PRIVATE externals numerics)

# Links with non-Siconos libraries

# GMP
find_package(GMP REQUIRED)
target_link_libraries(kernel PRIVATE GMP::GMP)

# Boost must be set as a public dependency because of SiconosAlgebraTypeDefs.hpp
# This has to be reviewed !!!
target_link_libraries(kernel PUBLIC Boost::boost)

if(WITH_BOOST_LOG)
  find_package(Boost 1.61 REQUIRED COMPONENTS log)
  target_compile_definition(kernel PRIVATE BOOST_LOG_DYN_LINK)
endif()

# --- python bindings ---
if(WITH_${COMPONENT}_PYTHON_WRAPPER)
  add_subdirectory(swig)
endif()

if(WITH_PYTHON_WRAPPER)
  add_dependencies(${COMPONENT} ${COMPONENT}_docstrings)
endif()  

# ---- Installation ----
# Call siconos_component_install_setup(<COMPONENT>)
# to prepare installation of the current target.
#
# Before, it's necessary to set:
# 
# - <COMPONENT>_INSTALL_INTERFACE_INCLUDE_DIRECTORIES with all directories
#    that contain headers files that must be installed.
# 
set(${COMPONENT}_INSTALL_INTERFACE_INCLUDE_DIRECTORIES
  ${${COMPONENT}_DIRS} # All .hpp are installed
  )

# List header files (in dir above) that must not be installed 
#set(${COMPONENT}_HDRS_EXCLUDE)

siconos_component_install_setup(${COMPONENT})

# --- tests ---
include(${COMPONENT}_tests.cmake)


# CHECK THIS LATER :
# --- set linked libraries and linker language ---
#set(${COMPONENT}_LINKER_LANGUAGE CXX)
# CMAKE_DL_LIBS for dlopen or equivalent (used for plugins)
#list(APPEND ${COMPONENT}_LINK_LIBRARIES ${CMAKE_DL_LIBS})

=== debian/changelog ===
siconos (4.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version. (Closes: #962219) (Closes: #961735)
  * Add dependencies libboost-timer-dev, libboost-chrono-dev.
  * Depend on openblas and lapacke instead of atlas.
  * Require fclib 3.1.0
  * Update location of install paths.
  * Enable WITH_GENERATION, now required for serialization.
  * Install new siconos_export_raw_data tool.
  * Fix cmake import targets to allow independent packages.
  * Update patches for new upstream version.
  * Add a flag for gfortran to avoid a regression in GCC-10.
    (Closes: #957794)
  * Remove unused build rule for swig3.0 symlink.
  * Remove non-existent files from debian/copyright.
  * Rewrite patch descriptions using gbp pq.
  * Fix a Python warning about using 'is' with a literal.
  * Patch for setup.py to import Command from distutils.core.
  * Patch to fix broken lapacke linkage.
  * Remove empty override_dh_auto_clean.
  * Patch to update use of node factory in breathe.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 07 Sep 2020 18:59:58 +0000

siconos (4.2.0+git20181026.0ee5349+dfsg.2-3) unstable; urgency=medium

  * Patch to remove bad cc options.
  * Patch to find python3.8 config.
  * Depend on swig instead of swig3.0.
  * Backport support for swig4.0. (Closes: #952601)
  * Removed a failing numerics test.
  * debian/rules: Remove use of ccache. (Closes: #945613 #954497)
  * Require Python 3.8.

 -- Stephen Sinclair <radarsat1@gmail.com>  Mon, 23 Mar 2020 21:11:30 +0000

=== debian/control ===
Source: siconos
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephen Sinclair <radarsat1@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12),
               dh-python,
               cmake (>= 3.0.2),
               libhdf5-dev (>= 1.10),
               libsuitesparse-dev (>= 1:5.1.2),
               libgmp3-dev,
               swig,
               libmumps-seq-dev,
               doxygen,
               graphviz,
               help2man,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               python3-sphinxcontrib.bibtex,
               python3-breathe,
               libbullet-dev,
               libboost-graph-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-timer-dev,
               libboost-chrono-dev,
               liblpsolve55-dev,
               liblapacke-dev,
               libopenblas-dev,
               gfortran,
               libcppunit-dev,
               libfclib-dev (>= 3.1.0),
               python3-lxml,
               python3-scipy,
               python3-numpy,
               python3-pytest,
               python3-vtk7,
               python3-h5py,
               python3-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/siconos
Vcs-Git: https://salsa.debian.org/science-team/siconos.git
Homepage: https://nonsmooth.gricad-pages.univ-grenoble-alpes.fr/siconos/index.html
Rules-Requires-Root: no
X-Python3-Version: >= 3.8

Package: siconos
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         cmake,
         libboost-serialization-dev (>= 1.61),
         libboost-filesystem-dev (>= 1.61),
         libsiconos-numerics-dev (= ${binary:Version}),
         libsiconos-kernel-dev (= ${binary:Version}),
         libsiconos-control-dev (= ${binary:Version}),
         libsiconos-mechanics-dev (= ${binary:Version}),
         libsiconos-io-dev (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (simulation runner tool)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the 'siconos' tool allowing to compile and run
 Siconos programs/scripts in a single command.

Package: siconos-mechanics-tools
Architecture: any
Multi-Arch: allowed
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         python3-siconos (= ${binary:Version}),
         python3-h5py (>= 2.8.0-1),
         python3-vtk7
Description: modeling and simulation of nonsmooth dynamical systems (mechanics tools)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains tools to allow running, analysing, manipulating,
 exporting, and viewing the output of mechanical simulations.

Package: libsiconos-numerics6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: modeling and simulation of nonsmooth dynamical systems (numerics lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the numerics component of
 Siconos, an interface to a collection of common numerical solvers.

Package: libsiconos-numerics-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libhdf5-dev (>= 1.10),
         libsuitesparse-dev (>= 1:5.1.2)
Description: modeling and simulation of nonsmooth dynamical systems (numerics dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the numerics
 component of Siconos, an interface to a collection of common
 numerical solvers.

Package: libsiconos-kernel6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (kernel lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the kernel component of Siconos.

Package: libsiconos-kernel-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-kernel6 (= ${binary:Version}),
         libsiconos-numerics-dev (= ${binary:Version}),
         libfclib-dev (>= 3.1.0),
         libsuitesparse-dev (>= 1:5.1.2),
         libboost-dev (>= 1.62.0.1),
         libgmp-dev (>= 2:6.1.2+dfsg-3)
Description: modeling and simulation of nonsmooth dynamical systems (kernel dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the development headers for the kernel
 component of Siconos.

Package: libsiconos-control6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-numerics6 (= ${binary:Version}),
         libsiconos-kernel6 (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control lib)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).
 Other applications are found in Systems and Control (hybrid systems,
 differential inclusions, optimal control with state constraints),
 Optimization (Complementarity systems and Variational inequalities),
 Fluid Mechanics, and Computer Graphics.
 .
 This package contains the library for the control component of Siconos.

Package: libsiconos-control-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsiconos-control6 (= ${binary:Version}),
         libsiconos-kernel-dev (= ${binary:Version})
Description: modeling and simulation of nonsmooth dynamical systems (control dev)
 Siconos is an open-source scientific software primarily targeted at
 modeling and simulating nonsmooth dynamical systems in C++ and in
 Python:
   * Mechanical systems (rigid or solid) with unilateral contact and
     Coulomb friction and impact (nonsmooth mechanics, contact dynamics,
     multibody systems dynamics or granular materials).
   * Switched Electrical Circuit such as electrical circuits with ideal
     and piecewise linear components: power converter, rectifier,
     Phase-Locked Loop (PLL) or Analog-to-Digital converter.
   * Sliding mode control systems.
   * Biology (Gene regulatory network).

=== debian/rules ===
#!/usr/bin/make -f

# TODO MPI? test with GlobalFrictionalContact3D_SparseBlockStorage
# TODO doc package

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

# GCC-10 promoted a warning to an error, creating a regression in hem5.f
export DEB_FCFLAGS_MAINT_APPEND=-fallow-argument-mismatch

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	TESTING=OFF
else
	TESTING=ON
endif

ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	CMAKE_VERBOSE_OFF=-DCMAKE_VERBOSE_MAKEFILE=OFF
endif

# Skip tests that consist of collections of tests, they take too long
# and time out.
TESTS_TO_SKIP=COLLECTION

# Skip this test as it depends on ql0001 which is not included due to
# copyright issues.
TESTS_TO_SKIP += python_test_lcp

BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)

# We disable parallel build because an 8 GB laptop runs out of memory
# with 4 parallel processes
%:
	dh $@ --with python3 --no-parallel --builddirectory=$(BUILDDIR)

# Notes: remove rpath due to Debian policy
override_dh_auto_configure:
	dh_auto_configure --                                       \
	-DCMAKE_SKIP_BUILD_RPATH=TRUE                              \
	-DFORCE_SKIP_RPATH=1                                       \
	-DCMAKE_SKIP_INSTALL_RPATH=TRUE                            \
	-DCMAKE_SKIP_RPATH=TRUE                                    \
	-DINSTALL_CMAKE_DIR=$(LIBDIR)/cmake/siconos                \
	-DPYTHON_EXECUTABLE=$(shell which python3)                 \
	-DI_WANT_STATIC_LPSOLVE=ON                                 \
	-DLpSolve_LIBRARY=/usr/lib/liblpsolve55_pic.a              \
	-DCMAKE_Fortran_FLAGS="$(FCFLAGS)"                         \
	-DWITH_TESTING=$(TESTING)                                  \
	-DWITH_DOCUMENTATION=ON                                    \
	-DWITH_DOXY2SWIG=ON                                        \
	-DWITH_SYSTEM_SUITESPARSE=ON                               \
	-DWITH_SERIALIZATION=ON                                    \
	-DWITH_GENERATION=ON                                       \
	-DWITH_BULLET=ON                                           \
	-DWITH_FCLIB=ON                                            \
	-DWITH_OCE=OFF                                             \
	-DIDONTWANTMPI=ON                                          \
	-DWITH_MUMPS=ON                                            \
	-Dpython_install_options="--install-layout=deb"            \
	$(CMAKE_VERBOSE_OFF)                                       \
	-Dtests_timeout=30

# Build ctest regular expression
null  :=
space := $(null) $(null)
or := |
TESTS_TO_SKIP := $(subst $(space),$(or),$(strip $(TESTS_TO_SKIP)))

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- ARGS="-E '$(TESTS_TO_SKIP)'"
endif

# Install software, headers, docs.
override_dh_auto_install:
	dh_auto_install

# Problem: ALL targets are checked even though we split them into
# separate packages, therefore attempting to use only
# e.g. libsiconos-kernel-dev fails due to libsiconos-control6 missing.
# Solution: Modify CMake targets to only check libraries for requested
# components.
	echo "cmake_policy(PUSH)" >tmp.cmake
	echo "cmake_policy(SET CMP0057 NEW)" >>tmp.cmake
	sed -e 's/list(APPEND _IMPORT_CHECK_TARGETS Siconos::\(\w*\) )/if(\1 IN_LIST siconos_FIND_COMPONENTS)\nlist(APPEND _IMPORT_CHECK_TARGETS Siconos::\1)\nendif()/' debian/tmp/usr/lib/cmake/siconos-4.3.0/siconosTargets-none.cmake >>tmp.cmake
	echo "cmake_policy(POP)" >>tmp.cmake
	mv tmp.cmake debian/tmp/usr/lib/cmake/siconos-4.3.0/siconosTargets-none.cmake
